#!/bin/bash
# COMPUTES CUMULATION (INTEGRAL) OF METER1 POWER CONSUMPTION
# PACKAGE 'bc' NEEDS TO BE INSTALLED FOR CALCULATIONS
# THIS SCRIPT MUST BE ADDED TO CRONTAB TO RUN EVERY MINUTE

year=$(date -d"$(date)" +%Y)
dates=$(cat "/opt/fhem/log/METER1-$year.log" | grep power | cut -d" " -f1)
data=$(cat /opt/fhem/log/METER1-$year.log | grep power | cut -d: -f4)

integral=0

i=0

#NO NEED TO COMPUTE EVERY MEASUREMENT -> step
step=3
second=$(echo $dates | cut -d" " -f$[$i+1])

while true
do
  i=$[$i+$step]

  first=$second
  second=$(echo $dates | cut -d" " -f$[$i+1])

  if [ -z "$second" ]; then
    break
  fi

  #COMPUTE EPOCH TIMES
  date1=$(echo $first | cut -d_ -f1)
  date2=$(echo $first | cut -d_ -f2)
  et1=$(date --date="$date1 $date2" "+%s")
  date1=$(echo $second | cut -d_ -f1)
  date2=$(echo $second | cut -d_ -f2)
  et2=$(date --date="$date1 $date2" "+%s")

  #DIFFERENCE IN TIME & MEAN OF THE TWO TIMES
  let "dt=$et2-$et1"
  mnT=$(bc <<< "($et1+$et2)/2")

  #GET DATA (POWER CONSUMPTION AT CERTAIN TIME)
  data1=$(echo $data | cut -d" " -f$i)
  data2=$(echo $data | cut -d" " -f$[$i+1])

  integral=$(bc -l <<< "scale=2; $integral+$dt*($data1+$data2)/2/3600")

  outDate=$(date -d @$mnT +%F_%T)

  if [ $i -eq $step ]; then
    echo $outDate METER1CUMUL power: $integral > /opt/fhem/log/MCTEMP.log
  else
    echo $outDate METER1CUMUL power: $integral >> /opt/fhem/log/MCTEMP.log
  fi
done

cp /opt/fhem/log/MCTEMP.log /opt/fhem/log/METER1CUMUL-$year.log
